function init()
    dlock1 = FindShape("lock1")
    dlock2 = FindShape("lock2")
	
    motors1 = FindJoints("motor1")
    motors2 = FindJoints("motor2")
	
	bdoor1 = FindShape("bathdoor1")
	bdoor2 = FindShape("bathdoor2")
	
	framelock1 = FindShape("dframelock1")
	framelock2 = FindShape("dframelock2")
	
	door1 = FindTrigger("doortrigger1")
	door2 = FindTrigger("doortrigger2")
	
	lock1 = FindTrigger("trigger1")
	lock2 = FindTrigger("trigger2")
	
	SetBool("level.bathdoorlock1", false)
	SetBool("level.bathdoorlock2", false)

end

function tick(dt)
	framebroken1 = IsShapeBroken(framelock1)
	framebroken2 = IsShapeBroken(framelock2)
	
	doorbroken1 = IsShapeBroken(dlock1)
	doorbroken2 = IsShapeBroken(dlock2)
	
	PlayerPos = GetPlayerPos()
	
	bathdoorlocked1 = GetBool("level.bathdoorlock1")
	bathdoorlocked2 = GetBool("level.bathdoorlock2")
    
	if IsPointInTrigger(lock1, PlayerPos) then
	    if bathdoorlocked1 then
            SetTag(dlock1, "interact", "locked")
		else
		    SetTag(dlock1, "interact", "unlocked")
		end
	else
	    RemoveTag(dlock1, "interact")
	end
	
	if IsPointInTrigger(lock2, PlayerPos) then
	    if bathdoorlocked2 then
            SetTag(dlock2, "interact", "locked")
		else
		    SetTag(dlock2, "interact", "unlocked")
		end
	else
	    RemoveTag(dlock2, "interact")
	end
	
	if IsShapeInTrigger(door1, bdoor1) then
	    if GetPlayerInteractShape() == dlock1 and InputPressed("interact") then
	        if not bathdoorlocked1 then
		        SetBool("level.bathdoorlock1", true)
	        else
		        SetBool("level.bathdoorlock1", false)
			end
	    end
	end
	
	if IsShapeInTrigger(door2, bdoor2) then
	    if GetPlayerInteractShape() == dlock2 and InputPressed("interact") then
	        if not bathdoorlocked2 then
		        SetBool("level.bathdoorlock2", true)
	        else
		        SetBool("level.bathdoorlock2", false)
			end
	    end
	end
	
	if not doorbroken1 and not framebroken1 then
	    if bathdoorlocked1 then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 10)
            end
	    else
		    if IsShapeInTrigger(door1, bdoor1) then
			    local body1 = GetPlayerGrabShape("bdoor1")
			    if body1 ~= 1 then
			        for i=1,#motors1 do
                        local motor1 = motors1[i]
                        SetJointMotorTarget(motor1, 0, 10, 10000)
					end
                end
			    if body1 ~= 0 then
                    for i=1,#motors1 do
                        local motor1 = motors1[i]
                        SetJointMotorTarget(motor1, 0, 0, 50)
					end
			    end
			end
        end
	end
	
	if not doorbroken2 and not framebroken2 then
	    if bathdoorlocked2 then
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 10)
            end
	    else
		    if IsShapeInTrigger(door2, bdoor2) then
			    local body2 = GetPlayerGrabShape("bdoor2")
			    if body2 ~= 1 then
			        for i=1,#motors2 do
                        local motor2 = motors2[i]
                        SetJointMotorTarget(motor2, 0, 10, 10000)
					end
                end
			    if body2 ~= 0 then
                    for i=1,#motors2 do
                        local motor2 = motors2[i]
                        SetJointMotorTarget(motor2, 0, 0, 50)
					end
			    end
			end
        end
	end
	
	if doorbroken1 or framebroken1 then
	    if bathdoorlocked1 then
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 50)
            end
	    else
            for i=1,#motors1 do
                local motor1 = motors1[i]
                SetJointMotorTarget(motor1, 0, 0, 50)
			end
        end
	end
	
	if doorbroken2 or framebroken2 then
	    if bathdoorlocked2 then
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 0, 50)
            end
	    else
            for i=1,#motors2 do
                local motor2 = motors2[i]
                SetJointMotorTarget(motor2, 0, 0, 50)
			end
        end
	end
end