function init()
	RegisterTool("poolcue", "Pool Cue", "MOD/tools/PoolCue/vox/poolcue.vox", 1)
	SetBool("game.tool.poolcue.enabled", true)
	SetFloat("game.tool.poolcue.ammo", 101)

	punchpower = GetFloat("savegame.mod.punchpower")
	if punchpower == 0 then punchpower = 100 end
	swingTimer = 0.1

	line = {}
	line.active = false
	damage = 0.0
	hitsound = LoadSound("MOD/snd/hitsound.ogg")
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, distance
end

function Punch()
	local forwardPos = TransformToParentPoint(GetCameraTransform(), Vec(0, 0, -1))
	local direction = VecSub(forwardPos, GetCameraTransform().pos)
	QueryRequire("physical")
	local hit, dist, normal, shape = QueryRaycast(GetCameraTransform().pos, direction, 3)
	if hit then
		PlaySound(hitsound, GetPlayerTransform().pos, 0.75, false)
		local body = GetShapeBody(shape)
		if IsBodyDynamic(body) then
			local mass = GetBodyMass(body)
			local scale = mass < 10 and punchpower/1 or punchpower*0.1
			local scale = mass > 10 and punchpower/1000 or punchpower*0.1
			local vel = VecScale(direction, 1.9)
			vel = VecScale(vel, scale)
			SetBodyVelocity(body, vel)
			MakeHole(direction.pos, damage*1, damage*1, damage*1)
		end
	end
	swingTimer = 0.35
end


function tick(dt)
	if GetString("game.player.tool") == "poolcue" and GetPlayerVehicle() == 0 then
		if InputPressed("usetool") then
			Punch()
		end
		local b = GetToolBody()
		if b ~= 0 then
			local offset = Transform(Vec(0, 0, 0), QuatEuler(0, 0, 0))
			SetToolTransform(offset)

			if swingTimer > 0 then
				local t = Transform()
				t.pos = Vec(0, 0, -swingTimer*3)
				t.rot = QuatEuler(swingTimer*0, 0, 0)
				SetToolTransform(t)

				swingTimer = swingTimer - dt
			end
		end
	end
end